local xresources = require 'beautiful.xresources'

local dpi = xresources.apply_dpi
local gfs = require 'gears.filesystem'
local theme = {}
local theme_assets = require 'beautiful.theme_assets'
local themes_path = gfs.get_themes_dir()
local xrdb = xresources.get_current_theme()

theme.font = 'monospace 11'
theme.wallpaper = '.cache/wal/bg'
theme.useless_gap = dpi(8)
theme.border_width = dpi(1)
theme.menu_height = dpi(15)
theme.menu_width = dpi(100)

-- Colors
theme.bg_focus = xrdb.color4
theme.bg_minimize = xrdb.color4
theme.bg_normal = xrdb.background
theme.bg_systray = theme.bg_normal
theme.bg_urgent = xrdb.color1

theme.border_focus = xrdb.color4
theme.border_marked = xrdb.color10
theme.border_normal = xrdb.color5

theme.fg_focus = xrdb.foreground
theme.fg_minimize = xrdb.foreground
theme.fg_normal = xrdb.foreground
theme.fg_urgent = xrdb.foreground

-- Generate taglist squares:
local taglist_square_size = dpi(4)

theme.taglist_squares_sel = theme_assets.taglist_squares_sel(taglist_square_size, theme.fg_normal)

theme.taglist_squares_unsel = theme_assets.taglist_squares_unsel(taglist_square_size, theme.fg_normal)

-- You can use your own layout icons like this:
theme.layout_cornerne = themes_path .. 'default/layouts/cornernew.png'
theme.layout_cornernw = themes_path .. 'default/layouts/cornernww.png'
theme.layout_cornerse = themes_path .. 'default/layouts/cornersew.png'
theme.layout_cornersw = themes_path .. 'default/layouts/cornersww.png'
theme.layout_dwindle = themes_path .. 'default/layouts/dwindlew.png'
theme.layout_fairh = themes_path .. 'default/layouts/fairhw.png'
theme.layout_fairv = themes_path .. 'default/layouts/fairvw.png'
theme.layout_floating = themes_path .. 'default/layouts/floatingw.png'
theme.layout_fullscreen = themes_path .. 'default/layouts/fullscreenw.png'
theme.layout_magnifier = themes_path .. 'default/layouts/magnifierw.png'
theme.layout_max = themes_path .. 'default/layouts/maxw.png'
theme.layout_spiral = themes_path .. 'default/layouts/spiralw.png'
theme.layout_tile = themes_path .. 'default/layouts/tilew.png'
theme.layout_tilebottom = themes_path .. 'default/layouts/tilebottomw.png'
theme.layout_tileleft = themes_path .. 'default/layouts/tileleftw.png'
theme.layout_tiletop = themes_path .. 'default/layouts/tiletopw.png'

-- Define the icon theme for application icons. If not set then the icons
-- from /usr/share/icons and /usr/share/icons/hicolor will be used.
theme.icon_theme = nil

return theme
